
local CO = require "api_coservice"
local MSG = require "api_msg"
local cjson = require "cjson"

local dset = {}



local upload = require "resty.upload"
STORE_PATH="/tmp/.web_upload/"
os.execute( "/bin/mkdir -p " .. STORE_PATH )



local function checkPartType(res)
	if type(res) == "table" then
		local idr = res[1]:lower()
		if idr == "content-disposition" then
			local fieldname, filename = res[2]:match('name=%"(.*)%".*filename=%"(.*)%"')
			if not fieldname then
				fieldname = res[2]:match('name=%"(.*)%"')
			end
			if not fieldname then
				return nil
			end
			if not filename then
				return "field", fieldname
			else
				return "file", fieldname, filename
			end
		elseif idr == "content-type" then
			return idr, res[2] or ""
		else
			return nil
		end
	else
		return nil
	end
end

local function getUploadFile(args)
	args = args or {}
	local form,err = upload:new(8192)
	if not form then
		return nil, "uploadErrorCreate"
	end
	form:set_timeout(5*1000)        --5secs timeout

	local fieldType, fieldName
	local srcFileName 
	local curFile

	while true do

		local typ, res, err = form:read()
		if not typ then
			if curFile then
				curFile:close()
			end
			return nil, "getUploadFileError"
		end

		if typ == "header" then
			local ftype,fname,filename = checkPartType(res)
			if ftype == "field" then
				fieldType = ftype
				fieldName = fname
				args[fieldName] = ""
			elseif ftype == "file" then
				fieldType = ftype
				fieldName = fname
				srcFileName = filename
				if srcFileName == "" then
					return nil, "InvalidFileError"
				end
			elseif ftype == "content-type" then
				if fieldType ~= "file" then
					if curFile then
						curFile:close()
					end
					return nil, "InvalidContentType"
				elseif fname ~= "image/jpeg" and fname ~="image/png" and fname ~="image/jpg" then
				-- elseif  fname ~="image/png"  then

					if curFile then
						curFile:close()
					end
					-- return nil, "上传文件必须是png文件"
					return nil, "invalidUploadType"
				else
					local openerrormsg
					-- curFile, openerrormsg = io.open( STORE_PATH  .. "logo.png", "wb" )
					STORE_PATH="/tmp/.web_upload/"
					ngx.log(ngx.ALERT, "-重置---STORE_PATH-------",STORE_PATH.. srcFileName)

					curFile, openerrormsg = io.open( STORE_PATH  .. srcFileName, "wb" )
					if not curFile then
						return nil, "uploadErrorCreate"
					end
					
				end
			else
				filedType = nil
				fieldName = nil
				if curFile then
					curFile:close()
					curFile = nil
				end
			end
		elseif typ == "body" then
			if fieldType == "field" then
				args[fieldName] = args[fieldName] .. res
			elseif fieldType == "file" then
				if not curFile then
					return nil, "uploadError"
				end
				curFile:write( res )
			end
		elseif typ == "part_end" then
			filedType = nil
			fieldName = nil
			if curFile then
				curFile:close()
				curFile = nil
			end
		elseif typ == "eof" then
			break
		end
	end

	if curFile then
		curFile:close()
	end

	if not srcFileName then
		return nil, "noneUpload"
	end
	math.randomseed(tostring(os.time()):reverse():sub(1, 6))
	local random_num = (math.random(1000))
	local time_name = os.time() 

	-- local file_,file_type = string.match(srcFileName,"(%a+).(%a+)")
	-- ngx.log(ngx.ALERT, "-string.match-------",file_,file_type)
	-- ngx.log(ngx.ALERT, "-old file-------",srcFileName)

	local num1,num2 = string.find(srcFileName,"%.")
	local file_type = string.sub(srcFileName,num1,-1)
	-- ngx.log(ngx.ALERT, "-new file-------",random_num .. time_name  .. file_type)

	os.execute("cp \"" .. STORE_PATH .. srcFileName .. "\"  /data/storage/img/".. random_num .. time_name  .. file_type)
	return random_num ..time_name .. file_type
end


--上传图片
local function API_upgrade(args)
	--TODO:上传4K文件导致proxy连接不上
	local srcFileName, err = getUploadFile(args)
	if not srcFileName then
		MSG.ERROR(err or "uploadError")
		return false, err or "uploadError"
	end
	--todo 将上传成功的图片 保存到数据库
	local tabs={}
	tabs.url = srcFileName
	tabs.name = args.name
	tabs.type = args.type
    local proxy = CO.GetProxy( "/pics", "picManager", "local", 30 )
	if proxy then
		local r, done, err = proxy.AddPic(tabs)
		proxy:Destroy()
		if r and done then
			MSG.OK()
		else
			MSG.ERROR(tostring(err) .. " this err from AddPic")
		end
	else
		MSG.ERROR("picManagerError")
	end
	return true
end


local function API_get(args)
    --查询分为  
    --type=all,查询所有图片
    --type=osd，
	--type=bg，--output

	local proxy = CO.GetProxy( "/pics", "picManager" )
	if proxy then
		local type = "all"
		if args.type ~= "all" then
			type = args.type
		end

		-- local r, done = proxy.GetPics(type,args.output)
		local r, done,position
		-- if args.output then
		-- 	r, done,position = proxy.GetOutputPics(args.output,type)
		-- else
			r, done = proxy.GetPics(type)
		-- end

		proxy:Destroy()
		if r and done then
			MSG.OK("",{data=done,position=position})
		else
			MSG.ERROR("searchPicError")
		end
	else
		MSG.ERROR( "picManagerError" )
	end

    return true
end

local function API_remove(args)
    if not args.id then
        MSG.ERROR( "argumentError" )
        return true
    end
	--todo 需要删除的图片信息告诉数据库
	local proxy = CO.GetProxy( "/pics", "picManager" )
	if proxy then
		local r, done ,err= proxy.RemovePic(args.id)
		proxy:Destroy()
		if r and done then
			MSG.OK("")
			return true
		else
			MSG.ERROR("delPicError")
			return  true
		end
	else
		MSG.ERROR("picManagerError")
		return true
	end
    return true
end

--背景图片选定及修改
local function API_modify(args)
    if not args.id or not args.output then
        MSG.ERROR( "argumentError" )
        return true
    end

	--todo 需要的图片信息告诉数据库
	local proxy = CO.GetProxy( "/pics", "picManager", "local",10)
	if proxy then
		--MSG.OK("")
		--ngx.eof()

		local tab={}
		tab.output = args.output
		tab.id = args.id
		tab.type = args.type
		tab.position = args.position
		tab.enable = args.enable

		local r, done = proxy.ModifyPic(tab)
		-- local r, done = proxy.ModifyPic(args.id,args.output,args.type,args.position or "",tonumber(args.enable))
		proxy:Destroy()
		if r and done then
			MSG.OK("")
			return true
		else
			MSG.ERROR( "bgModifyError" )
			return true
		end
	else
		MSG.ERROR( "picManagerError" )
		return true
	end
    return true
end

-----------------------------
dset.APIS = dset.APIS or {}

dset["get"] = API_get
dset["add"] = API_upgrade
dset["remove"] = API_remove
dset["modify"] = API_modify

--------------------------------------
return dset
