local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/staticroute.conf"
}

--------------------------------------------------------
local record_setting_template = DC.SET(
    DC.OBJ({
    interface = DC.STR(),
    target = DC.STR(),
    netmask = DC.STR("255.255.255.255"),
	gateway = DC.STR("0.0.0.0"),
	metric = DC.INT(0), 
	mtu = DC.INT(1500),
	status = DC.INT(),
}) : __changed( function(conf)
	conf:TAB_SAVE()
end)
) : __changed( function(conf)
	conf:TAB_SAVE()
end)

-------------------------------------------------------
function _M.Load()
	local conf = CONF.Create({}, record_setting_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
    local _, r = conf:TAB_LOAD()
    if not r then
		conf:TAB_BIND( {} )
    end
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------
return _M
