local _dbg = require "coaf.debug"
local cjson = require "cjson"
local pl = require "pl.pretty"
local mod_pic = require "mod_picManager"

local client = require "coaf.client"
local adapter = require "coaf.cli_adapter.simple"
client.InitSocket(nil, adapter)

local _M = {
    
}

--------------------------------

function _M.GetProxy(objPath, service, loc, timeout, addr)
	local proxy
	local cli

	cli = client.New( service, loc, addr, timeout or 3 ) --3 seconds timeout.
	if not cli then
		_dbg.Error( "CO", "Fail to create connection to service '" .. (loc or "local") .. "/" .. (service or "nil") )
		return nil
	end
	proxy = cli:CreateProxy(objPath, true) --Exclusive
	if not proxy then
		_dbg.Error( "CO", "Fail to create object proxy for '" .. (objPath or "unknown") .. "'" )
		return nil
    end
	return proxy
end


function _M.getHideInfo(output,type)
    local datas = {}
    local data=_M.GetHomePicInfos()

    for i=1,#data do
        if type then
            if tonumber(data[i].output) == tonumber(output) and data[i].type==type then
                table.insert(datas,data[i])
            end
        else
            if tonumber(data[i].output) == tonumber(output) then
                table.insert(datas,data[i])
            end
        end
    end
    return datas
end



--快速隐藏图片logo 或者bg
function _M.fastHide(output,type,enable)
    local proxy
    if type == "bg" then
        local outputid
        if output == "1" then
            outputid = "hd0"
        elseif output == "2" then
            outputid = "hd1"
        end
        proxy = _M.GetProxy( "/output/"..outputid, "codec" )
    elseif type == "osd" then
        proxy = _M.GetProxy( "/osd", "OSD" )
    end
	if not proxy then
		return false, "serverOSDError"
    else
        local r, done, err
        if type == "bg" then
            -- print(output,type,enable)
            if enable == 0 or enable == "0" then
                r, done, err = proxy.DisableGroundOSD()
            else
                local pt = require "pl.pretty"
                -- pt.dump(cfg_imgRelation["output"..output][type])
                if cfg_imgRelation["output"..output][type] and cfg_imgRelation["output"..output][type].url then
                    r, done, err = proxy.setBackGround(cfg_imgRelation["output"..output][type].url)
                else
                    _dbg.Error("picManager", "pic Config error!")
                end
            end
        elseif type == "osd" then
            r, done, err = proxy.enableImg(tonumber(output),type,tonumber(enable))
        end
        proxy:Destroy()
        if not r or not done then
            _dbg.Error("快速打开/关闭 输出的叠加/背景图片失败!!!!err:",err)
            return false,"fastSetBGError"
        end
    end
    cfg_imgRelation["output"..output][type].enable = tonumber(enable)
    cfg_imgRelation:__TRIGGER(true)

    return true
end


function _M.GetHomePicInfos()
    local datas = {}
    for outtype,tabs in pairs(cfg_imgRelation) do
        local output
        if outtype=="output1"  then
            output=1
        else
            output=2
        end
        for Bg_Osd,tab in pairs(tabs) do
            local w,h = mod_pic.GetPicRate(tab.url)
            local data = {}
            data={
                output = output,
                type = Bg_Osd,
                enable = tab.enable,
                url = tab.url,
                position = tab.position,
                w = w,
                h = h,
            }
            table.insert(datas,data)
        end
    end
    return datas
end


function _M.CheckPicUsed(pic_name)
    --检查某张图片有没有被osd模块叠加
    for outtype,tabs in pairs(cfg_imgRelation) do
        for Bg_Osd,tab in pairs(tabs) do
            if tab.url == pic_name then
                return 1
            end
        end
    end
    return 0
end

return _M
