local _dbg = require "coaf.debug"
local client = require "coaf.client"
local adapter = require "coaf.cli_adapter.simple"

adapter.timeoutUnit = 1000

local proxyDict = {}

local function GetProxy(objPath, service, loc, timeout, socket_addr)
	for level = 1, 4 do
		for _, name in ipairs({"S", "l", "n"}) do
			for k, v in pairs(debug.getinfo(level, name)) do
				-- print(string.format("level = %s, name = %s, key = %s, value - %s", level, name, k, v))
			end
		end
	end
	-- if proxyDict[service] and proxyDict[service][objPath] then
	-- 	-- print("OCLLOG : ------------------- Already have this proxy:", service, objPath)
	-- 	return proxyDict[service][objPath]
	-- end
	-- print("OCLLOG : +++++++++++++++++++++ New this proxy:", service, objPath)
	local cli = client.New( service, loc, socket_addr, timeout or 5 )
	if not cli then
		_dbg.Error( "GetCoAFProxy", "Fail to create connection to service " .. (loc or "local") .. "/" .. (service or "nil") )
		return nil
	end

	local proxy = cli:CreateProxy(objPath, true) --Exclusive
	if not proxy then
		_dbg.Error( "GetCoAFProxy", "Fail to create object proxy for '" .. (objPath or "unknown") .. "'" )
		return nil
	end
	-- print("=========================== return the proxy = ", proxy)
	return proxy
end


local ServiceObjPath = {
	codec = {"/codec", "/streamer", "/capture"},
	network = {"/network"}
}

for _, service in ipairs({"codec", "network"}) do
	for _, objPath in ipairs(ServiceObjPath[service]) do
		-- proxyDict[service] = proxyDict[service] or {}
		-- local proxy = GetProxy(objPath, service)
		-- proxy.Destroy = function(v) print("in Proxy Destroy, v = ", v) end
		-- proxy.__gc = function() print("in Proxy __gc") end
		
		-- proxyDict[service][objPath] = proxy
	end
end


return GetProxy

