local _dbg = require "coaf.debug"
local client = require "coaf.client"
local adapter = require "coaf.cli_adapter.simple"
client.InitSocket( nil, adapter )

local function GetProxy(objPath, service, loc, timeout, socket_addr)
	local cli = client.New( service, loc, socket_addr, timeout or 5 )
	if not cli then
		_dbg.Error( "GetCoAFProxy", "Fail to create connection to service " .. (loc or "local") .. "/" .. (service or "nil") )
		return nil
	end
	local proxy = cli:CreateProxy(objPath, true) --Exclusive
	if not proxy then
		_dbg.Error( "GetCoAFProxy", "Fail to create object proxy for '" .. (objPath or "unknown") .. "'" )
		return nil
	end

	return proxy
end

return GetProxy