local DC = require "supertable.declare"
local CONF = require "supertable.core"
local _M = {
	config_file = "/data/configs/ptz.conf"
}
local function OnDeviceChanged(obj)
	-- local ptz_mod = require "ptzModule"
	-- ptz_mod.Config()
end

local function OnOptionsChanged(obj)
	-- local ptz_mod = require "ptzModule"
	-- ptz_mod.Config()
end

local function OnSocketChanged(obj)
	-- local ptz_mod = require "ptzModule"
	-- ptz_mod.Config()
end

local PTZ_Template = DC.OBJ{
	deviceType = DC.STR("net"),
	device = DC.OBJ{
		device = DC.STR("null"),
		baudrate = DC.INT(9600),
		databits = DC.INT(8),
		parity = DC.STR("none"),
		stopbits = DC.INT(1),
		xonxoff = DC.INT(0),
		rtscts = DC.INT(0),
	} : __changed( OnDeviceChanged ),

	socket_svc = DC.OBJ{
		protocol = DC.STR("TCP"),
		addr = DC.STR("192.168.43.188"),
		port = DC.INT(52381),
	} : __changed( OnSocketChanged ),

	options = DC.OBJ{
		protocol = DC.STR("visca"),
		address = DC.INT(1),
		pan_speed = DC.NUM(0.5),
		tilt_speed = DC.NUM(0.5),
		zoom_speed = DC.NUM(0.5),
		focus_speed = DC.NUM(0.5),
		iris_speed = DC.NUM(0.5),
	} : __changed( OnOptionsChanged ),

	presets = DC.ARR(
		DC.OBJ{
			token = DC.STR(""),
			name = DC.STR(""),
		}
	)
} : __changed( function(conf)
	conf:TAB_SAVE()
end)

local default = {}

function _M.Load()
	local conf = CONF.Create({}, PTZ_Template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
    if not r then
		conf:TAB_BIND( default )
    end
	conf:TAB_RESET_CHANGE()
	return conf
end

return _M
