print("Running File __tds__GetCapabilities.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local response = {
	Capabilities = {}
}

local i
local hostAddr = GLOBAL_INFO.GetHostAddress()

if type(request.Category) ~= "table" then
	request.Category = { tt__CapabilityCategory__All }
end

for i=1, #request.Category do
	if request.Category[i] == tt__CapabilityCategory__All or
		request.Category[i] == tt__CapabilityCategory__Analytics then
		response.Capabilities.Analytics = {
			XAddr = "http://" .. hostAddr .. "/onvif/analytics_service",
			RuleSupport = 0,
			AnalyticsModuleSupport = 0
		}
	end
	
	if request.Category[i] == tt__CapabilityCategory__All or
		request.Category[i] == tt__CapabilityCategory__Device then
		response.Capabilities.Device = {
			XAddr = "http://" .. hostAddr .. "/onvif/device_service",
			Network = {
				IPFilter = 0,
				ZeroConfiguration = 0,
				IPVersion6 = 0,
				DynDNS = 0,
				Extension = {
					Dot11Configuration = 0 --TODO: Support it?
				}
			},

			System = {
				DiscoveryResolve = 0,
				DiscoveryBye = 0,
				RemoteDiscovery = 0,
				SystemBackup = 0,
				SystemLogging = 0,
				FirmwareUpgrade = 0,
				SupportedVersions = {
					Major = 2, Minor = 0
				},
				
				Extension = {
					HttpFirmwareUpgrade = 1,
					HttpSystemBackup = 1,
					HttpSystemLogging = 1,
					HttpSupportInformation = 1
				}
			},
		
			IO = {
				InputConnectors = 0,
				RelayOutputs = 0,
			},
			
			Security = {
				TLS1_x002e1 = 0,
				TLS1_x002e2 = 0,
				OnboardKeyGeneration = 0,
				AccessPolicyConfig = 0,
				X_x002e509Token = 0,
				SAMLToken = 0,
				KerberosToken = 0,
				RELToken = 0
			}
		}
	end

--[[
	if request.Category[i] == tt__CapabilityCategory__All or
		request.Category[i] == tt__CapabilityCategory__Events then
		response.Capabilities.Events = {
			XAddr = "http://" .. hostAddr .. "/onvif/event_service",
			WSSubscriptionPolicySupport = 0,
			WSPullPointSupport = 0,
			WSPausableSubscriptionManagerInterfaceSupport = 0
		}
	end
]]

	if request.Category[i] == tt__CapabilityCategory__All or
		request.Category[i] == tt__CapabilityCategory__Imaging then
		
		response.Capabilities.Imaging = {
			XAddr = "http://" .. hostAddr .. "/onvif/imaging_service"
		}
	end

	if request.Category[i] == tt__CapabilityCategory__All or
		request.Category[i] == tt__CapabilityCategory__Media then

		response.Capabilities.Media = {
			XAddr = "http://" .. hostAddr .. "/onvif/media_service",
			StreamingCapabilities = {
				RTPMulticast = 1,
				RTP_USCORETCP = 1,
				RTP_USCORERTSP_USCORETCP = 1
			},
			Extension = {
				ProfileCapabilities = {
					MaximumNumberOfProfiles = 4	--?? spec to 2?
				}
			}
		}
	end

	if request.Category[i] == tt__CapabilityCategory__All or
		request.Category[i] == tt__CapabilityCategory__PTZ then
		response.Capabilities.PTZ = {
			XAddr = "http://" .. hostAddr .. "/onvif/ptz_service",
		}
	end

	if request.Category[i] == tt__CapabilityCategory__All then
		break --Get all, so break the loop.
	end
end

return response

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

