print("Running File __tds__GetDNS.lua")

local allDNS = {}
local manualDNS = {}

local file = io.open( "/etc/resolv.conf", "r" )
if file then
	local line = file:read("l")
	while line do
		if not line:match( "^%s*#.*" ) then	--Not be comment
			local addr = line:match( "nameserver%s+([0-9%.]+)" )
			if addr then
				table.insert( allDNS, addr )
			end
		end
		line = file:read( "l" )
	end
	file:close()
end

local dhcp = -1

local GetProxy = require "GetProxy"
local proxy = GetProxy("/network", "network")

local is_ok, data = proxy.GetLinkDetail("eth0")
proxy:Destroy()
if is_ok then
	dhcp = data.method == "static" and 0 or 1
	local dns_tbl = split(data.dns, ",")
	for _, v in ipairs(dns_tbl) do
		manualDNS[v] = true
	end
end
local dhcpDNS = {}
local mDNS = {}
for k,v in pairs(allDNS) do
	if manualDNS[v] then
		table.insert( mDNS, { Type = tt__IPType__IPv4 , IPv4Address = v } )
	else
		table.insert( dhcpDNS, { Type = tt__IPType__IPv4 , IPv4Address = v } )
	end
end

return {
	DNSInformation = {
		FromDHCP = dhcp and 1 or 0,
		SearchDomain = allDNS,
		DNSManual = mDNS,
		DNSFromDHCP = dhcpDNS
	}
}

--[==[ *ABSTRACT* The 'response' arguments:
{
	DNSInformation: (!)
	{
		FromDHCP: (!)
		(
			xsd__boolean__false_: 0,
			xsd__boolean__true_: 1,
		)
		__sizeSearchDomain: <int>
		SearchDomain: <char**>
		__sizeDNSFromDHCP: <int>
		DNSFromDHCP[...]: 
		{
			Type: (!)
			(
				tt__IPType__IPv4: 0,
				tt__IPType__IPv6: 1,
			)
			IPv4Address: <char*>
			IPv6Address: <char*>
		}
		__sizeDNSManual: <int>
		DNSManual[...]: 
		{
			Type: (!)
			(
				tt__IPType__IPv4: 0,
				tt__IPType__IPv6: 1,
			)
			IPv4Address: <char*>
			IPv6Address: <char*>
		}
		Extension: 
		{
			__size: <int>
			__any: <_XML>
		}
		__anyAttribute: <_XML>
	}
}
]==]

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

