print("Running File __tds__GetNTP.lua")
local response = {
	NTPInformation = {
		FromDHCP = 0
	}
}

local GetProxy = require "GetProxy"
local proxy = GetProxy("/datetime", "systemctrl")
if not proxy then
	return response
end

local is_ok, isNtp, items = proxy.GetNtp()
if not is_ok then
	return response
end

response.NTPInformation.NTPManual = {}

items = items .. " "
local x
for x in items:gmatch("(.-)%s+") do
	if x:match( "^[0-9%.]+$" ) then	--It's IP address
		table.insert( response.NTPInformation.NTPManual, {
			Type = tt__NetworkHostType__IPv4,
			IPv4Address = x
		})
	else
		table.insert( response.NTPInformation.NTPManual, {
			Type = tt__NetworkHostType__DNS,
			DNSname = x
		})
	end
end

return response
--[==[ *ABSTRACT* The 'response' arguments:
{
	NTPInformation: (!)
	{
		FromDHCP: (!)
		(
			xsd__boolean__false_: 0,
			xsd__boolean__true_: 1,
		)
		__sizeNTPFromDHCP: <int>
		NTPFromDHCP[...]: 
		{
			Type: (!)
			(
				tt__NetworkHostType__IPv4: 0,
				tt__NetworkHostType__IPv6: 1,
				tt__NetworkHostType__DNS: 2,
			)
			IPv4Address: <char*>
			IPv6Address: <char*>
			DNSname: <char*>
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
			__anyAttribute: <_XML>
		}
		__sizeNTPManual: <int>
		NTPManual[...]: 
		{
			Type: (!)
			(
				tt__NetworkHostType__IPv4: 0,
				tt__NetworkHostType__IPv6: 1,
				tt__NetworkHostType__DNS: 2,
			)
			IPv4Address: <char*>
			IPv6Address: <char*>
			DNSname: <char*>
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
			__anyAttribute: <_XML>
		}
		Extension: 
		{
			__size: <int>
			__any: <_XML>
		}
		__anyAttribute: <_XML>
	}
}
]==]


