print("Running File __tds__GetNetworkInterfaces.lua")
local response = {
	NetworkInterfaces = {}
}

local function maskCheckByte(b)
	local cc
	local r = 0
	for cc = 1, 8, 1 do
		if (b & 0x80) > 0 then
		-- if bit.band(b,0x80) > 0 then
			r = r + 1
		else
			return r
		end
		b = b << 1
		-- b = bit.lshift(b,1)
	end
	return r
end

local function netmask2prefix(netmask)
	local tbl = {
		["0.0.0.0"] = 0,
		["255.0.0.0"] = 8,
		["255.255.0.0"] = 16,
		["255.255.255.0"] = 24,
		["255.255.255.255"] = 32,
	}
	if tbl[netmask] then
		return tbl[netmask]
	end
	
	local prefix = 0
	local nums = split(netmask, ".")
	for _, num in ipairs(nums) do
		num = tonumber(num)
		if num == 255 then
			prefix = prefix + 8
		else
			prefix = prefix + maskCheckByte(num)
		end
	end

	return prefix
end


-- local GetProxy = require "GetProxy"
-- local proxy = GetProxy("/network", "network")

-- local is_ok, data = proxy.GetLinkDetail("eth0")
-- print("**************** is_ok = ", is_ok)
-- local pt = require "pl.pretty"
-- pt.dump(data)
-- print("===========================")
-- proxy:Destroy()
-- if not is_ok then
-- 	return response
-- end
local data = {
	address = "192.168.35.133",
	mac = "66:68:91:57:D6:69",
	aliases = {
	  enable = true,
	  gw2 = "",
	  address = "192.168.1.132",
	  address2 = "",
	  gw = "",
	  netmask2 = "255.255.255.0",
	  netmask = "255.255.255.0"
	},
	status = "up",
	method = "static",
	gw = "192.168.35.254",
	dns = "8.8.8.8",
	netmask = "255.255.255.0"
  }

local GetProxy = require "GetProxy"
local proxy = GetProxy("/network", "network")
local is_ok, data = proxy.GetLinkDetail("eth0")

local item = {
	token = "eth0",
	Enabled = data.status == "up" and 1 or 0,
	Info = {
		HwAddress = data.mac,

		Name = data.Name,
		MTU = 1472	--TODO: Assume it always be this.
	},
	Link = {
		InterfaceType = 6, --ethernet/AllTypes.
		AdminSettings = {
			AutoNegotiation = 1,
			Speed = 100,
			Duplex = 0, --Full
		},
		
		OperSettings = {
			AutoNegotiation = 1,
			Speed = 100,
			Duplex = 0
		},
	},
	
	IPv4 = {
		Enabled = 1,
		Config = {
			DHCP = data.method == "static" and 0 or 1,
			FromDHCP = {
				Address = data.address,
				PrefixLength = netmask2prefix(data.netmask),
			},
			Manual = {
				Address = data.address,
				PrefixLength = netmask2prefix(data.netmask),
			}
		}
	}
}

table.insert(response.NetworkInterfaces, item)

--First step, check-out all wired interfaces.
--TODO: 这里只获取了 eth0的信息，后续需要获取所有网卡信息
return response
