print("Running File __tds__GetNetworkProtocols.lua")
-- local busOprs = require "busOprs"

-- local cc, gets = busOprs.Get( {
-- 	["streamer.stream[0].Rtsp_server.port"] = 554,
-- 	["streamer.stream[1].Rtsp_server.port"] = 554,
-- 	["webConfig.port"] = 80,
-- 	["webConfig.https_port"] = 443,
-- } )

-- local ports = { gets and gets["streamer.stream[0].Rtsp_server.port"] or 554 }
-- local second_port = gets and gets["streamer.stream[1].Rtsp_server.port"] or 554
-- if ports[1] ~= second_port then
-- 	ports[2] = second_port
-- end

local GetProxy = require "GetProxy"
local proxy = GetProxy("/webDaemon", "systemctrl")
local http, https
if proxy then
	local is_ok, info = proxy.GetInfo()
	proxy:Destroy()
	if is_ok then
		http = info.port
		https = info.https_port
	end
end

local ports = {}
local saved = {}
local rtspEnable = 0
local proxy = GetProxy("/streamer", "codec")
if proxy then
	local is_ok, data = proxy.GetInfo()
	proxy:Destroy()
	if is_ok then
		for _, stream in pairs(data) do
			for _, v in ipairs(stream) do
				if v.type == "rtsp" and not saved[v.port] then
					table.insert(ports, v.port)
					saved[v.port] = true
				end
			end
		end
	end
end

rtspEnable = #ports == 0 and 0 or 1

return {
	NetworkProtocols = {
		{
			Name = tt__NetworkProtocolType__HTTP,
			Enabled = _G.onvif.control.enabled,
			Port = { http or 80 } --_G.onvif.control.port, 
		},
		
		{
			Name = tt__NetworkProtocolType__HTTPS,
			Enabled = _G.onvif.control.enabled,
			Port = { https or 443 }
		},

		{
			Name = tt__NetworkProtocolType__RTSP,
			Enabled = 1,
			Port = ports
		}
	}
}

