print("Running File __tds__SetDNS.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

if request.FromDHCP == 0 and request.DNSManual then	--Manual DNS set
	local dns={}
	local i
	for i=1,#request.DNSManual do
		if request.DNSManual[i].Type == tt__IPType__IPv4 then
			--print( request.DNSManual[i].IPv4Address )
			table.insert(dns, request.DNSManual[i].IPv4Address )
		end
	end
	
	local GetProxy = require "GetProxy"
	local proxy = GetProxy("/network", "network")
	if proxy then
		local is_ok, data = proxy.GetLinkDetail("eth0")
		if is_ok then
			data.dns = dns
			proxy.ChangeConnection("eth0", data)
		end
		proxy:Destroy()
	end
	
	return SVC_OK	--TODO: ???
else
	return SVC_OK
end


--[==[ *ABSTRACT* The 'request' arguments:
{
	FromDHCP: (!)
	(
		xsd__boolean__false_: 0,
		xsd__boolean__true_: 1,
	)
	__sizeSearchDomain: <int>
	SearchDomain: <char**>
	__sizeDNSManual: <int>
	DNSManual[...]: 
	{
		Type: (!)
		(
			tt__IPType__IPv4: 0,
			tt__IPType__IPv6: 1,
		)
		IPv4Address: <char*>
		IPv6Address: <char*>
	}
}
]==]


