print("Running File __tds__SetNTP.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

if request.FromDHCP ~= 1 and request.NTPManual then
	local list = {}
	for i=1, #request.NTPManual do
		if request.NTPManual[i].Type == tt__NetworkHostType__IPv4 then
			table.insert(list, request.NTPManual[i].IPv4Address)
		elseif request.NTPManual[i].Type == tt__NetworkHostType__DNS then
			table.insert(list, request.NTPManual[i].DNSname)
		end
	end

	local GetProxy = require "GetProxy"
	local proxy = GetProxy("/datetime", "systemctrl")
	if proxy then
		local is_ok, isNtp = proxy.GetNtp()
		if is_ok then
			proxy.SetNtp(isNtp, table.concat(list, " "))
		end
		proxy:Destroy()
	end
end

return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	FromDHCP: (!)
	(
		xsd__boolean__false_: 0,
		xsd__boolean__true_: 1,
	)
	__sizeNTPManual: <int>
	NTPManual[...]: 
	{
		Type: (!)
		(
			tt__NetworkHostType__IPv4: 0,
			tt__NetworkHostType__IPv6: 1,
			tt__NetworkHostType__DNS: 2,
		)
		IPv4Address: <char*>
		IPv6Address: <char*>
		DNSname: <char*>
		Extension: 
		{
			__size: <int>
			__any: <_XML>
		}
		__anyAttribute: <_XML>
	}
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
}
]==]


