print("Running File __tds__SetNetworkDefaultGateway.lua")
local busOprs = require "busOprs"
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

if request.IPv4Address then
	local GetProxy = require "GetProxy"
	local proxy = GetProxy("/network", "network")
	if proxy then
		local is_ok, data = proxy.GetLinkDetail(request.InterfaceToken)
		if is_ok or not data then
			local update = true
			if request.NetworkInterface.IPv4.DHCP ~= 0 then
				data.method = "dhcp"
			elseif type(request.NetworkInterface.IPv4.Manual) == "table" then
				data.method = "static"
				data.address = request.NetworkInterface.IPv4.Manual[1].Address or data.address
				data.netmask = request.NetworkInterface.IPv4.Manual[1].PrefixLength and OnvifSvc.Net.AddressMatch( "255.255.255.255", "255.255.255.255", request.NetworkInterface.IPv4.Manual[1].PrefixLength) or data.netmask
			else
				update = false
			end
			if update then
				proxy.ChangeConnection(request.InterfaceToken, data)
			end
		end --of get 'devices'
		proxy:Destroy()
	end




	local devices = busOprs.GetIfDevices("*")	--Get all devices.
	if devices then
		local k,v
		for k,v in pairs(devices) do
			if v.TypeName == "ETHERNET" and v.State > 10 then
				local ifconfig = busOprs.CheckIfConfig( v.Object, "WIRE" )
				if not ifconfig.dhcp then
					local i
					local matchAddr = nil
					for i=1, #request.IPv4Address do
						if OnvifSvc.Net.AddressMatch( request.IPv4Address[i], ifconfig.ip4addr, ifconfig.prefix ) then
							matchAddr = request.IPv4Address[i]
							break
						end
					end
					
					if matchAddr then
						local args = {
							obj = v.Object,
							uuid = ifconfig.uuid,
							dynamic = 'n',
							ip = ifconfig.ip4addr,
							mask = ifconfig.ip4mask,
							gw = matchAddr,
							dns1 = ifconfig.ip4dns1,
							dns2 = ifconfig.ip4dns2,
							specConn = ifconfig.specConn,
						}
					
						busOprs.SetWireIfConfig(args)
						busOprs.UpdateIfConfig(v.Object)
					end --of if matched gateway address.
				end --if not DHCP
			end -- if ethernet
		end --For
	end --get 'devices'
	
	return SVC_OK	--TODO: ???
else
	return SVC_OK
end

--[==[ *ABSTRACT* The 'request' arguments:
{
	__sizeIPv4Address: <int>
	IPv4Address: <char**>
	__sizeIPv6Address: <int>
	IPv6Address: <char**>
}
]==]

