print("Running File __tds__SetNetworkProtocols.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local GetProxy = require "GetProxy"
-- local streamProxy = GetProxy("/streamer", "codec")
local webProxy = GetProxy("/webDaemon", "systemctrl")
local webUpdate = {}
local streamerUpdate = {}
local rtspCC = 0
if request.NetworkProtocols then
	local i
	for i=1, #request.NetworkProtocols do
		if request.NetworkProtocols[i].Name == tt__NetworkProtocolType__HTTP or request.NetworkProtocols[i].Name == tt__NetworkProtocolType__HTTPS then
			if request.NetworkProtocols[i].Enabled == 0 then	--Disable Onvif service
				_G.onvif.control.enabled = 0
			elseif request.NetworkProtocols[i].Port then
				_G.onvif.control.enabled = 1
				if request.NetworkProtocols[i].Port[1] then
					if request.NetworkProtocols[i].Name == tt__NetworkProtocolType__HTTPS then
						webUpdate.https_port = request.NetworkProtocols[i].Port[1]
					else
						webUpdate.port = request.NetworkProtocols[i].Port[1]
					end
				end
			end

		elseif request.NetworkProtocols[i].Name == tt__NetworkProtocolType__RTSP and request.NetworkProtocols[i].Enabled and request.NetworkProtocols[i].Port then
			local j
			for j=1, #request.NetworkProtocols[i].Port do
				rtspCC = rtspCC + 1
				if rtspCC == 1 then
					-- streamerUpdate.main = streamerUpdate.main or {}
					-- streamerUpdate.sub = streamerUpdate.sub or {}
					-- streamerUpdate.sub.port = 
					-- streamerUpdate.main.port = 
					-- sets["streamer.stream[0].Rtsp_server.port"] = request.NetworkProtocols[i].Port[j]
					-- sets["streamer.stream[1].Rtsp_server.port"] = request.NetworkProtocols[i].Port[j]	--Sub stream is same as main.
				else
					-- sets["streamer.stream[1].Rtsp_server.port"] = request.NetworkProtocols[i].Port[j]
				end
			end
		end
	end --For.
	
	if webProxy then
		if next(webUpdate) then
			webProxy.UpdateNginx({
				port = webUpdate.port,
				https_port = webUpdate.https_port
			})
		end
		webProxy:Destroy()
	end

	_G.onvif:__TRIGGER(true)

end


return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	__sizeNetworkProtocols: <int> (!)
	NetworkProtocols[...]: (!)
	{
		Name: (!)
		(
			tt__NetworkProtocolType__HTTP: 0,
			tt__NetworkProtocolType__HTTPS: 1,
			tt__NetworkProtocolType__RTSP: 2,
		)
		Enabled: (!)
		(
			xsd__boolean__false_: 0,
			xsd__boolean__true_: 1,
		)
		__sizePort: <int> (!)
		Port: <int*> (!)
		Extension: 
		{
			__size: <int>
			__any: <_XML>
		}
		__anyAttribute: <_XML>
	}
}
]==]


