print("Running File __tds__SetSystemDateAndTime.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local GetProxy = require "GetProxy"
local proxy = GetProxy("/datetime", "systemctrl")
if not proxy then
	return SVC_OK
end

if request.DateTimeType == tt__SetDateTimeType__NTP then
	proxy.SetNtp(true)
else
	--TODO: Now ignored timezone settting.
	-- local is_ok, location, offset = proxy.GetLocation()
	
	if request.UTCDateTime and request.UTCDateTime.Date and request.UTCDateTime.Time then
		local timeStr = request.UTCDateTime.Date.Year .. "-" .. 
						request.UTCDateTime.Date.Month .. "-" ..
						request.UTCDateTime.Date.Day .. " " ..
						request.UTCDateTime.Time.Hour .. ":" ..
						request.UTCDateTime.Time.Minute .. ":" ..
						request.UTCDateTime.Time.Second
						
		proxy.SetNtp(false)
		--NOTE: 使用 V2.2.250 版本的onvif，计算机时区为 +8,
		--通过onvif设置的时间如果是2点，那么这里收到的时间是10点，onvif发送的时候已经做了时区处理，所以这里不需要再做
		-- proxy.SetLocation("America/Danmarkshavn", 0) 
		proxy.SetDatetime(timeStr)
		-- proxy.SetLocation(location, offset)
	end
end

proxy:Destroy()

return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	DateTimeType: (!)
	(
		tt__SetDateTimeType__Manual: 0,
		tt__SetDateTimeType__NTP: 1,
	)
	DaylightSavings: (!)
	(
		xsd__boolean__false_: 0,
		xsd__boolean__true_: 1,
	)
	TimeZone: 
	{
		TZ: <char*> (!)
	}
	UTCDateTime: 
	{
		Time: (!)
		{
			Hour: <int> (!)
			Minute: <int> (!)
			Second: <int> (!)
		}
		Date: (!)
		{
			Year: <int> (!)
			Month: <int> (!)
			Day: <int> (!)
		}
	}
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
}
]==]


