print("Running File __tds__SetUser.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local function SetUser( username, password, level )
	if not username or not level then
		return
	end
	
	if username == "admin" then --This is special
		if password then
			_G.onvif.adminPassword = password
		end
	else
		for i, v in ipairs(_G.onvif.users) do
			if v.username == username then
				if password then
					v.password = password
				end
				if level then
					if level == tt__UserLevel__Administrator then
						v.role = "admin"
					elseif level == tt__UserLevel__Operator then
						v.role = "operator"
					elseif level == tt__UserLevel__User then
						v.role = "user"
					elseif level == tt__UserLevel__Anonymous then
						v.role = "anonymous"
					elseif level == tt__UserLevel__Extended then
						v.role = "extended"
					end
				end
				break
			end
		end
	end
	_G.onvif:__TRIGGER(true)
end

local i
for i=1, #request.User do
	SetUser( request.User[i].Username, request.User[i].Password, request.User[i].UserLevel )
end

return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	__sizeUser: <int> (!)
	User[...]: (!)
	{
		Username: <char*> (!)
		Password: <char*>
		UserLevel: (!)
		(
			tt__UserLevel__Administrator: 0,
			tt__UserLevel__Operator: 1,
			tt__UserLevel__User: 2,
			tt__UserLevel__Anonymous: 3,
			tt__UserLevel__Extended: 4,
		)
		Extension: 
		{
			__size: <int>
			__any: <_XML>
		}
		__anyAttribute: <_XML>
	}
}
]==]



