print("Running File __timg__GetImagingSettings.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local GetProxy = require "GetProxy"
local proxy = GetProxy("/capture", "codec")
local data, is_ok
if proxy then
	is_ok, data = proxy.GetInfo()
	proxy:Destroy()
end

--[==[ *ABSTRACT* The 'request' arguments:
{
	VideoSourceToken: <char*> (!)
}
]==]

return {
	ImagingSettings = {
		Brightness = data and data[1].brightness or 128,
		ColorSaturation = data and data[1].saturation or 128,
		Contrast = data and data[1].contrast or 128,
	}
}

--[==[ *ABSTRACT* The 'response' arguments:
{
	ImagingSettings: (!)
	{
		BacklightCompensation: 
		{
			Mode: (!)
			(
				tt__BacklightCompensationMode__OFF: 0,
				tt__BacklightCompensationMode__ON: 1,
			)
			Level: <float*>
		}
		Brightness: <float*>
		ColorSaturation: <float*>
		Contrast: <float*>
		Exposure: 
		{
			Mode: (!)
			(
				tt__ExposureMode__AUTO: 0,
				tt__ExposureMode__MANUAL: 1,
			)
			Priority: 
			(
				tt__ExposurePriority__LowNoise: 0,
				tt__ExposurePriority__FrameRate: 1,
			)
			Window: 
			{
				bottom: <float*>
				top: <float*>
				right: <float*>
				left: <float*>
			}
			MinExposureTime: <float*>
			MaxExposureTime: <float*>
			MinGain: <float*>
			MaxGain: <float*>
			MinIris: <float*>
			MaxIris: <float*>
			ExposureTime: <float*>
			Gain: <float*>
			Iris: <float*>
		}
		Focus: 
		{
			AutoFocusMode: (!)
			(
				tt__AutoFocusMode__AUTO: 0,
				tt__AutoFocusMode__MANUAL: 1,
			)
			DefaultSpeed: <float*>
			NearLimit: <float*>
			FarLimit: <float*>
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
			__anyAttribute: <_XML>
		}
		IrCutFilter: 
		(
			tt__IrCutFilterMode__ON: 0,
			tt__IrCutFilterMode__OFF: 1,
			tt__IrCutFilterMode__AUTO: 2,
		)
		Sharpness: <float*>
		WideDynamicRange: 
		{
			Mode: (!)
			(
				tt__WideDynamicMode__OFF: 0,
				tt__WideDynamicMode__ON: 1,
			)
			Level: <float*>
		}
		WhiteBalance: 
		{
			Mode: (!)
			(
				tt__WhiteBalanceMode__AUTO: 0,
				tt__WhiteBalanceMode__MANUAL: 1,
			)
			CrGain: <float*>
			CbGain: <float*>
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
			__anyAttribute: <_XML>
		}
		Extension: 
		{
			__size: <int>
			__any: <_XML>
			ImageStabilization: 
			{
				Mode: (!)
				(
					tt__ImageStabilizationMode__OFF: 0,
					tt__ImageStabilizationMode__ON: 1,
					tt__ImageStabilizationMode__AUTO: 2,
					tt__ImageStabilizationMode__Extended: 3,
				)
				Level: <float*>
				Extension: 
				{
					__size: <int>
					__any: <_XML>
				}
				__anyAttribute: <_XML>
			}
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
		}
		__anyAttribute: <_XML>
	}
}
]==]


