print("Running File __timg__Move.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local ptz = require "ptzModule"
if not ptz or not ptz.ptz_obj then
	return SVC_OK
end

pcall( require, "features" )

if request.Focus then
	if request.Focus.Absolute then
		print( "IMG: Move Absolute:", request.Focus.Absolute.Position )
		return SVC_OK
	elseif request.Focus.Relative then
		print( "IMG: Move Relative:", request.Focus.Relative.Distance )
		return SVC_OK
	elseif request.Focus.Continuous then
		local spd = request.Focus.Continuous.Speed
		print( "IMG: Move continuous...", spd )
		if spd < 0 then
			if _G.OEM_TYPE == "E1_BOCOM" then
				ptz.ptz_obj:IrisUp()
			else
				ptz.ptz_obj:FocusNear(-spd)
			end
		else
			if _G.OEM_TYPE == "E1_BOCOM" then
				ptz.ptz_obj:IrisDown()
			else
				ptz.ptz_obj:FocusFar(spd)
			end
		end
	end
end

return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	VideoSourceToken: <char*> (!)
	Focus: (!)
	{
		Absolute: 
		{
			Position: <float> (!)
			Speed: <float*>
		}
		Relative: 
		{
			Distance: <float> (!)
			Speed: <float*>
		}
		Continuous: 
		{
			Speed: <float> (!)
		}
	}
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
}
]==]


--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

