print("Running File __timg__SetImagingSettings.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local GetProxy = require "GetProxy"
local proxy = GetProxy("/capture", "codec")
local is_ok, data = proxy.GetInfo()
if request.ImagingSettings and proxy then

	local brightness = data and data[1].brightness
	local contrast = data and data[1].contrast
	local saturation = data and data[1].saturation
	if request.ImagingSettings.Brightness then
		brightness = math.floor( request.ImagingSettings.Brightness )
	end

	if request.ImagingSettings.ColorSaturation then
		saturation = math.floor( request.ImagingSettings.ColorSaturation )
	end

	if request.ImagingSettings.Contrast then
		contrast = math.floor( request.ImagingSettings.Contrast )
	end

	proxy.UpdateColor(1, brightness, contrast, saturation)
	proxy:Destroy()
end

return SVC_OK


--[==[ *ABSTRACT* The 'request' arguments:
{
	VideoSourceToken: <char*> (!)
	ImagingSettings: (!)
	{
		BacklightCompensation: 
		{
			Mode: (!)
			(
				tt__BacklightCompensationMode__OFF: 0,
				tt__BacklightCompensationMode__ON: 1,
			)
			Level: <float*>
		}
		Brightness: <float*>
		ColorSaturation: <float*>
		Contrast: <float*>
		Exposure: 
		{
			Mode: (!)
			(
				tt__ExposureMode__AUTO: 0,
				tt__ExposureMode__MANUAL: 1,
			)
			Priority: 
			(
				tt__ExposurePriority__LowNoise: 0,
				tt__ExposurePriority__FrameRate: 1,
			)
			Window: 
			{
				bottom: <float*>
				top: <float*>
				right: <float*>
				left: <float*>
			}
			MinExposureTime: <float*>
			MaxExposureTime: <float*>
			MinGain: <float*>
			MaxGain: <float*>
			MinIris: <float*>
			MaxIris: <float*>
			ExposureTime: <float*>
			Gain: <float*>
			Iris: <float*>
		}
		Focus: 
		{
			AutoFocusMode: (!)
			(
				tt__AutoFocusMode__AUTO: 0,
				tt__AutoFocusMode__MANUAL: 1,
			)
			DefaultSpeed: <float*>
			NearLimit: <float*>
			FarLimit: <float*>
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
			__anyAttribute: <_XML>
		}
		IrCutFilter: 
		(
			tt__IrCutFilterMode__ON: 0,
			tt__IrCutFilterMode__OFF: 1,
			tt__IrCutFilterMode__AUTO: 2,
		)
		Sharpness: <float*>
		WideDynamicRange: 
		{
			Mode: (!)
			(
				tt__WideDynamicMode__OFF: 0,
				tt__WideDynamicMode__ON: 1,
			)
			Level: <float*>
		}
		WhiteBalance: 
		{
			Mode: (!)
			(
				tt__WhiteBalanceMode__AUTO: 0,
				tt__WhiteBalanceMode__MANUAL: 1,
			)
			CrGain: <float*>
			CbGain: <float*>
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
			__anyAttribute: <_XML>
		}
		Extension: 
		{
			__size: <int>
			__any: <_XML>
			ImageStabilization: 
			{
				Mode: (!)
				(
					tt__ImageStabilizationMode__OFF: 0,
					tt__ImageStabilizationMode__ON: 1,
					tt__ImageStabilizationMode__AUTO: 2,
					tt__ImageStabilizationMode__Extended: 3,
				)
				Level: <float*>
				Extension: 
				{
					__size: <int>
					__any: <_XML>
				}
				__anyAttribute: <_XML>
			}
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
		}
		__anyAttribute: <_XML>
	}
	ForcePersistence_x0020: 
	(
		xsd__boolean__false_: 0,
		xsd__boolean__true_: 1,
	)
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
}
]==]


