print("Running File __tptz__ContinuousMove.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local GetProxy = require "GetProxy"
local proxy = GetProxy("/PTZ", "ptz")
if request.Velocity and proxy then
	if request.Velocity.PanTilt then
		local pt = request.Velocity.PanTilt
		if pt.x < 0 then
			-- ptz.ptz_obj:MoveLeft( -pt.x )
			proxy.PTZObjControl("MoveLeft", -pt.x)
		elseif pt.x > 0 then
			-- ptz.ptz_obj:MoveRight( pt.x )
			proxy.PTZObjControl("MoveRight", pt.x)
		end

		if pt.y < 0 then
			proxy.PTZObjControl("MoveDown", -pt.y)
			-- ptz.ptz_obj:MoveDown( -pt.y )
		elseif pt.y > 0 then
			proxy.PTZObjControl("MoveUp", pt.y)
			-- ptz.ptz_obj:MoveUp( pt.y )
		end
	end
	
	if request.Velocity.Zoom then
		local zm = request.Velocity.Zoom
		if zm.x < 0 then
			proxy.PTZObjControl("ZoomOut", -zm.x)
			-- ptz.ptz_obj:ZoomOut(-zm.x)
		elseif zm.x > 0 then
			proxy.PTZObjControl("ZoomIn", zm.x)
			-- ptz.ptz_obj:ZoomIn(zm.x)
		end
	end
	proxy:Destroy()
end
return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	ProfileToken: <char*> (!)
	Velocity: (!)
	{
		PanTilt: 
		{
			x: <float> (!)
			y: <float> (!)
			space: <char*>
		}
		Zoom: 
		{
			x: <float> (!)
			space: <char*>
		}
	}
	Timeout: <LONG64*>
}
]==]

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

