print("Running File __tptz__GetPresets.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local preset = {}
for i, v in ipairs(_G.ptz.presets) do
	local item = {Name = v.name, token = v.token}
	if item.Name == "" then
		item.Name = string.format( "Preset%03d", i )
	end
	table.insert(preset. item)
end

return { Preset = preset }


--[==[ *ABSTRACT* The 'request' arguments:
{
	ProfileToken: <char*> (!)
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
	__sizePreset: <int>
	Preset[...]: 
	{
		Name: <char*>
		PTZPosition: 
		{
			PanTilt: 
			{
				x: <float> (!)
				y: <float> (!)
				space: <char*>
			}
			Zoom: 
			{
				x: <float> (!)
				space: <char*>
			}
		}
		token: <char*>
		__anyAttribute: <_XML>
	}
}
]==]

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

