print("Running File __tptz__GetStatus.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

return {
	PTZStatus = {
		Position = {
			PanTilt = { x=0, y=0 },
			Zoom = { x=0 }
		},

		MoveStatus = {
			PanTilt = 0,
			Zoom = 0
		},

		UtcTime = os.time()
	}
}

--[==[ *ABSTRACT* The 'request' arguments:
{
	ProfileToken: <char*> (!)
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
	PTZStatus: (!)
	{
		Position: 
		{
			PanTilt: 
			{
				x: <float> (!)
				y: <float> (!)
				space: <char*>
			}
			Zoom: 
			{
				x: <float> (!)
				space: <char*>
			}
		}
		MoveStatus: 
		{
			PanTilt: 
			(
				tt__MoveStatus__IDLE: 0,
				tt__MoveStatus__MOVING: 1,
				tt__MoveStatus__UNKNOWN: 2,
			)
			Zoom: 
			(
				tt__MoveStatus__IDLE: 0,
				tt__MoveStatus__MOVING: 1,
				tt__MoveStatus__UNKNOWN: 2,
			)
		}
		Error: <char*>
		UtcTime: <time_t> (!)
		__size: <int>
		__any: <_XML>
		__anyAttribute: <_XML>
	}
}
]==]

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

