print("Running File __tptz__GotoHomePosition.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local GetProxy = require "GetProxy"
local proxy = GetProxy("/PTZ", "ptz")
if not proxy then
	return SVC_OK
end

local is_ok, data = proxy.GetInfo()
if is_ok then
	print("data.presets[0] = ", data.presets[0])
	print("TOKEN = ",  data.presets[0] and data.presets[0].token)
	if data.presets[0] and data.presets[0].token == "9999" then
		proxy.PTZObjControl("LoadPreset", 0)
		-- ptz_m.ptz_obj:LoadPreset(0)
	else
		proxy.PTZObjControl("MoveHome")
		-- ptz_m.ptz_obj:MoveHome()
	end
end

proxy:Destroy()
return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	ProfileToken: <char*> (!)
	Speed: 
	{
		PanTilt: 
		{
			x: <float> (!)
			y: <float> (!)
			space: <char*>
		}
		Zoom: 
		{
			x: <float> (!)
			space: <char*>
		}
	}
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
}
]==]

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

