print("Running File __tptz__GotoPreset.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local GetProxy = require "GetProxy"
local proxy = GetProxy("/PTZ", "ptz")
if not proxy then
	return SVC_OK
end

local is_ok, data = proxy.GetInfo()
--print( "PTZ: GotoPreset: token=", request.PresetToken )
print("request.PresetToken = ", request.PresetToken)
if request.PresetToken and data then
	local tok
	for i, v in pairs(data.presets) do
		if v.token == request.PresetToken then
			tok = i
			break
		end
	end
	
	if not tok then
		tok = tonumber( request.PresetToken:match("[0-9]+") )
	end

	proxy.PTZControl({action = "load-preset", id=tok})
end

proxy:Destroy()
return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	ProfileToken: <char*> (!)
	PresetToken: <char*> (!)
	Speed: 
	{
		PanTilt: 
		{
			x: <float> (!)
			y: <float> (!)
			space: <char*>
		}
		Zoom: 
		{
			x: <float> (!)
			space: <char*>
		}
	}
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
}
]==]

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

