print("Running File __tptz__RelativeMove.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local ptz = require "ptzModule"
if not ptz or not ptz.ptz_obj then
	return SVC_OK
end


if request.Translation then
	local speed_pt
	local speed_zm

	if request.Speed then
		speed_pt = request.Speed.PanTilt
		speed_zm = request.Speed.Zoom
	end

	if request.Translation.PanTilt then
		local pt = request.Translation.PanTilt
		if pt.x < 0 then
			ptz.ptz_obj:MoveLeft( speed_pt and speed_pt.x or nil )
		elseif pt.x > 0 then
			ptz.ptz_obj:MoveRight( speed_pt and speed_pt.x or nil )
		end

		if pt.y < 0 then
			ptz.ptz_obj:MoveDown( speed_pt and speed_pt.y or nil )
		elseif pt.y > 0 then
			ptz.ptz_obj:MoveUp( speed_pt and speed_pt.y or nil )
		end
	end
	
	if request.Translation.Zoom then
		local zm = request.Translation.Zoom
		if zm.x < 0 then
			ptz.ptz_obj:ZoomOut(speed_zm and speed_zm.x or nil)
		elseif zm.x > 0 then
			ptz.ptz_obj:ZoomIn(speed_zm and speed_zm.x or nil)
		end
	end

	return SVC_OK
else
	return SVC_OK
end

--[==[ *ABSTRACT* The 'request' arguments:
{
	ProfileToken: <char*> (!)
	Translation: (!)
	{
		PanTilt: 
		{
			x: <float> (!)
			y: <float> (!)
			space: <char*>
		}
		Zoom: 
		{
			x: <float> (!)
			space: <char*>
		}
	}
	Speed: 
	{
		PanTilt: 
		{
			x: <float> (!)
			y: <float> (!)
			space: <char*>
		}
		Zoom: 
		{
			x: <float> (!)
			space: <char*>
		}
	}
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
}
]==]

return response

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

