print("Running File __tptz__RemovePreset.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local GetProxy = require "GetProxy"
local proxy = GetProxy("/PTZ", "ptz")
if not proxy then
	return SVC_OK
end

local is_ok, data = proxy.GetInfo()
if not is_ok then
	return SVC_OK
end
if request.PresetToken then
	local pos
	for i, v in pairs(data.presets) do
		if v.token == request.PresetToken then
			pos = i
			break
		end
	end

	if pos then
		data.presets[pos] = nil
		proxy.Update(data)
		proxy.PTZObjControl("RemovePreset", pos)
	end

end

return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	ProfileToken: <char*> (!)
	PresetToken: <char*> (!)
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
}
]==]

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

