print("Running File __tptz__SetPreset.lua")
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local GetProxy = require "GetProxy"
local proxy = GetProxy("/PTZ", "ptz")
if not proxy then
	return SVC_OK
end

local is_ok, data = proxy.GetInfo()
if not is_ok then
	return SVC_OK
end

local freePos, update
local xstr = request.PresetToken or request.PresetName
if xstr then
	xstr = xstr:match("[0-9]+")
end

if xstr then
	freePos = tonumber(xstr)
else	
	local update
	for i, v in pairs(data.presets) do
		if v.token == request.PresetToken and request.PresetToken ~= "" then
			freePos = i
			update = true
			break
		end
	end
end

if freePos or update then
	local tok = request.PresetToken or string.format( "%03d",freePos )
	if freePos and data.presets[freePos] then
		data.presets[freePos].token = tok
		data.presets[freePos].name = request.PresetName or tok
	else
		freePos = freePos or #data.presets + 1
		data.presets[freePos] = {
			token = tok,
			name = request.PresetName or tok
		}
		
	end

	proxy.Update(data)
	proxy.PTZControl({action = "save-preset", id = freePos})
end

proxy:Destroy()
return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	ProfileToken: <char*> (!)
	PresetName: <char*>
	PresetToken: <char*>
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
	PresetToken: <char*> (!)
}
]==]

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

